LeetCode-17-电话号码的字母组合

一:题目描述:

给定一个仅包含数字 2-9 的字符串,返回所有它能表示的字母组合。答案可以按 任意顺序 返回。

给出数字到字母的映射如下(与电话按键相同)。注意 1 不对应任何字母。

二:示例与提示

示例 1:

复制代码
输入:digits = "23"
输出:["ad","ae","af","bd","be","bf","cd","ce","cf"]

示例 2:

复制代码
输入:digits = ""
输出:[]

示例 3:

复制代码
输入:digits = "2"
输出:["a","b","c"]

提示:

  • 0 <= digits.length <= 4
  • digits[i] 是范围 ['2', '9'] 的一个数字。

三:思路

回溯

对于这种不同集合之间的组合,一开始会去想着,两个集合用两个for循环,三个集合三个for循环,但是我们无法去控制几个for循环,所以就想到用递归来控制for循环,再想到组合问题也需要用到回溯

  • 利用一个数组存储对应的下标的字符
  • 可以模拟构建一个树形结构
  • 横向拓展由for循环控制对digit的遍历
  • 纵向拓展由递归函数进行回溯
  • 需要注意该题是两个集合的组合,不是一个集合的组合,考虑用index变量控制

四:代码 + 复杂度分析

回溯+剪枝

js 复制代码
/**
 * @param {string} digits
 * @return {string[]}
 */
var letterCombinations = function(digits) {
    //回溯
    //用数组下标对应字符
    const map = ["", "", "abc", "def", "ghi","jkl", "mno", "pqrs", "tuv", "wxyz"]
    if(digits.length === 0) return []
    if(digits.length === 1) return map[digits].split("")
    //存储结果
    const res = []
    //单个结果
    const path = []
    const backtracking = (digits, index) => {
        if(digits.length === path.length) {
            //拼接起来
            //ad
            console.log(path)
            res.push(path.join(''))
            return 
        }
        for(let i of map[digits[index]]) {
            //['a', 'd']
            path.push(i)
            backtracking(digits, index + 1)
            path.pop()
        }
    }

    backtracking(digits, 0)
    return res
};
  • 时间复杂度:O(3 ^ m * 4 ^ m)

    • 在最坏情况下,每个数字都映射到一个包含 3 或 4 个字符的集合(例如,数字 '2' 对应 "abc",数字 '7' 对应 "pqrs")。
  • 空间复杂度: O(n + k)

    • res 数组用于存储最终的字母组合,因此其空间复杂度是 O(k),其中 k 表示可能的字母组合数量。
    • path 数组用于存储当前的组合路径,它的最大长度等于输入数字字符串的长度,因此其空间复杂度为 O(n),其中 n 表示输入数字字符串的长度。
相关推荐
海绵宝宝转agent9 小时前
JUC高频面试八股总结个人开源
面试·职场和发展
Nil20810 小时前
leetcode 118杨辉三角
算法·leetcode·职场和发展
wanderist.12 小时前
线性筛法详解:从筛质数到欧拉函数、Möbius 函数与约数函数
java·数据结构·算法
All for pursuit.12 小时前
【设计-1】208.实现Trie (前缀树)
数据结构·c++·算法·leetcode
weixin_3077791313 小时前
C++代码实现MATLAB中的crossval函数功能
开发语言·c++·算法·matlab
青少儿编程课堂13 小时前
背包问题(0/1 背包与完全背包)解题精讲——动态规划入门
c++·python·算法·bfs·信息学竞赛
光影少年13 小时前
为什么 JavaScript 中 0.1 + 0.2 !== 0.3,如何让其相等?
前端·javascript·算法
HEJOO913 小时前
Linux 设备驱动系列——使用全局工作队列
java·linux·算法
Code_Solitude14 小时前
c语言:递归
java·c语言·算法
我命由我1234514 小时前
Photoshop - Photoshop 使用内容识别填充移除对象
学习·职场和发展·产品运营·求职招聘·职场发展·学习方法·photoshop